"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactAddons = require("react/addons");

var React = _interopRequire(_reactAddons);

var Reflux = _interopRequire(require("reflux"));

var _ = _interopRequire(require("lodash"));

var ReactMixin = _interopRequire(require("react-mixin"));

var Component = _reactAddons.Component;

var TXStore = _interopRequire(require("../Store"));

var utils = _interopRequire(require("../utils"));

var defaultProps = { filter: {}, keys: ["pending", "received", "dropped", "failed", "confirmed"] };
var baseState = {
  pending: [],
  received: [],
  dropped: [],
  failed: [],
  confirmed: [],

  timestamp: 0,
  blockNumber: 0,
  blockHash: ""
};

module.exports = function (Component) {
  var WrappedComponent = React.createClass({
    displayName: "WrappedComponent",

    //class WrappedComponent extends Component {
    /*
    constructor(props, context) {
      super(props, context);
      this.state = _.cloneDeep(baseState);
    },
    */
    mixins: [Reflux.ListenerMixin],
    getDefaultProps: function getDefaultProps() {
      return _.cloneDeep(defaultProps);
    },
    getInitialState: function getInitialState() {
      return _.cloneDeep(baseState);
    },

    parseStore: function parseStore(state, props) {
      if (typeof props === "undefined") props = this.props;

      var filter = _.get(this.props, "filter", {});

      // Updated state
      var filteredState = _.cloneDeep(baseState);

      var accounts = _.get(this.props, "account", []);
      var types = _.get(this.props, "keys", []);

      accounts = utils.toArr(accounts);

      if (!accounts.length) accounts = Object.keys(_.get(state, "accounts", {}));

      accounts.filter(function (account) {
        return account !== "children";
      }).forEach(function (account) {
        types.forEach(function (type) {
          var typeStates = _.get(state.accounts, [account, type], {
            nonces: []
          });

          var filteredTypeStates = _.filter(typeStates.nonces.reduce(function (a, nonce) {
            return a.concat(utils.toArr(typeStates[nonce]));
          }, []).map(function (hash) {
            return state.info[hash];
          }), filter).map(function (info) {
            return {
              info: info,
              data: state.objects[info.hash],
              receipt: _.get(state.receipts, info.hash, null)
            };
          });

          filteredState[type] = filteredState[type].concat(filteredTypeStates);
        });
      });

      ["blockNumber", "blockHash", "timestamp"].forEach(function (key) {
        filteredState[key] = state[key];
      });

      this.setState(filteredState);
    },

    componentDidMount: function componentDidMount() {
      console.log("componentDidMount");
      this.listenTo(TXStore, this.parseStore);
      this.parseStore(TXStore.state, this.props);
    },

    componentDidUpdate: function componentDidUpdate(oldProps, oldState) {
      this.parseStore(TXStore.state, this.props);
    },

    // Don't rerender children without change in props or state
    shouldComponentUpdate: function shouldComponentUpdate(nextProps, nextState) {
      var res = !_.isEqual(this.props, nextProps) || !_.isEqual(this.state, nextState);
      console.log("WrappedComponent.this", this.props.personas.a489e5492cb525fead809c496a1a1db67318d24a);
      console.log("WrappedComponent.next", nextProps.personas.a489e5492cb525fead809c496a1a1db67318d24a);
      console.log("WrappedComponent.currentAccount.this", this.props.currentAccount);
      console.log("WrappedComponent.currentAccount.next", nextProps.currentAccount);
      console.log("WrappedComponent.shouldComponentUpdate", res);
      return res;
    },

    getExtraProps: function getExtraProps() {
      var p = _.omit(this.props, Object.keys(defaultProps));
      console.log("extraprops", p);
      return p;
    },

    render: function render() {
      console.log("RENDER");
      return React.createElement(Component, _extends({ ref: "component" }, this.getExtraProps(), this.state));
    }
  });

  //WrappedComponent.defaultProps = defaultProps;
  //ReactMixin.onClass(WrappedComponent, Reflux.ListenerMixin);
  //ReactMixin(WrappedComponent.prototype, Reflux.ListenerMixin);
  return WrappedComponent;
};